require "Model.Config.Levels"
module("Model.Play.HeadInfo.UIHeadInfo", MOInherit(Model.Base.UIBase))

function OnActivate(self)
	local scheduler = CCDirector:sharedDirector():getScheduler()
	self.m_timerEntry = scheduler:scheduleScriptFunc(function(dt) self:UpdateTimer(dt) end, 1, false)
	self.m_handlerEventBaseInfoChanged = GBaseInfo:AddListener("Event_BaseInfo_Changed",function(args) self.m_leftTime = nil Update(self,args) end)
end
function OnDeactivate(self)
	local scheduler = CCDirector:sharedDirector():getScheduler()
	scheduler:unscheduleScriptEntry(self.m_timerEntry)
	GBaseInfo:RemoveListener("Event_BaseInfo_Changed",self.m_handlerEventBaseInfoChanged)
end

function UIHeadInfo_OnTouch(self,eventType)
	if eventType == CCTOUCHENDED then		
		if self.idMainPart:isVisible() then
			GPlay:AddUI("PlayerInfo")
		end
	end
	do return end
	if eventType == CCTOUCHBEGAN then
		GPlay:AddUI("PlayerInfo")
	elseif eventType == CCTOUCHENDED or eventType == CCTOUCHCANCELLED then
		self.m_script:FindModelComponent("/Play/PlayerInfo","Script"):RemoveSelf()
	end
end
function Vip_OnTouch(self,eventType)
	if eventType == CCTOUCHENDED then		
		GPlay:AddUI("Pay")
	end
end

function Update(self)
	self.idName:setString(GBaseInfo:GetMasterName());
	--self.idLevel:setString("");
	self.idLevel:setString("Lv. "..GBaseInfo:GetLevel());
	local icon = GBaseInfo:GetIcon()
	self.idMasterHead:setDisplayFrameWithFile("Res/PlayerHead/head-"..icon..".png")
	local energy = GBaseInfo:GetEnergy();
	local exp = GBaseInfo:GetExp();
	
	self.idEnergyProgress:setPercentage(energy*100/100);	
	self.idEnergyProgressText:setString(""..energy.."/".. 100);	
		
	local nlJindu = (energy/100);
	if nlJindu > 1.0 then
		nlJindu = 1.0
	end
	
	nlJindu = 231-( nlJindu * 231 );	
	
	self.idEnergySprite:setPosition(CCPointMake(nlJindu,10))
	
	-- VIP 设置为null
	--self.idVipLevel:setString("Lv. "..GBaseInfo:GetLevel())
	local vipLv = GBaseInfo:GetVipLevel();
	if vipLv < 10 then
		self.idVipLevel:setString("V I P     "..vipLv)
	else
		self.idVipLevel:setString("V I P  "..vipLv)
	end
	
	local curlevelexp = Model.Config.Levels.GetMasterLevelExp(GBaseInfo:GetLevel())
	
	--[[local percentage = math.floor(self.idExpProgress:getPercentage())
	local newpercentage = math.floor(exp*100/curlevelexp)
	if newpercentage > percentage then
		self.idExpProgress:stopAllActions()
		local action = CCProgressFromTo:create(0.5,percentage,newpercentage)
		self.idExpProgress:runAction(action)
	elseif newpercentage < percentage then
		self.idExpProgress:stopAllActions()
		local action = CCProgressFromTo:create(0.5,1,newpercentage)
		self.idExpProgress:runAction(action)
		self.idExpProgress:setPercentage(newpercentage);
	end--]]
	
	self.idZhenYing:setDisplayFrameWithFile("Res/UIPlay/zheying"..GBaseInfo:GetCamp().."-min.png")
	self.idShenZi:setDisplayFrameWithFile("Res/Exploit/"..GBaseInfo:GetPriesthood()..".png")
	self.idExpProgress:setPercentage(exp*100/curlevelexp);
	-- self.idExpProgress:setPercentage(100);
	local jindu = (exp/curlevelexp);
	jindu = jindu * 488;
	self.idExpSprite:setPositionX(jindu)
	--self.idExpProgressText:setString(exp.."/".. curlevelexp);
	self.idExpProgressText:setString("经验:");
	if not self.m_leftTime then
		self.m_leftTime = GBaseInfo:GetEnergyRestoreLeft()
	end	
	
	local oldmoney = tonumber(self.idMoney:getString())	or -1
	local newmoney = GBaseInfo:GetMoney()
	if oldmoney~= newmoney and oldmoney~=-1 then
		self:StartCoroutine("PlayAddMoney","PlayAddMoney",oldmoney,newmoney)
	end		
	self.idMoney:setString(GBaseInfo:GetMoney());	
	
	
	local oldgold = tonumber(self.idGold:getString())	or -1
	local newgold = GBaseInfo:GetGold()
	if oldgold~= newgold and oldgold~=-1 then
		self:StartCoroutine("PlayAddGold","PlayAddGold",oldgold,newgold)
	end		
	self.idGold:setString(GBaseInfo:GetGold());		
end

function PlayAddMoney(self,oldmoney,newmoney)
	local framenum = 30
	for i=1,framenum do
		self.idMoney:setString(oldmoney +  math.floor((newmoney - oldmoney)*i/framenum))
		coroutine.yield()
	end
	self.idMoney:setString(GBaseInfo:GetMoney());	
end

function PlayAddGold(self,oldgold,newgold)
	local framenum = 30
	for i=1,framenum do
		self.idGold:setString(oldgold +  math.floor((newgold - oldgold)*i/framenum))
		coroutine.yield()
	end
	self.idGold:setString(GBaseInfo:GetGold());	
end

function UpdateTimer(self,dt)
	if not self.m_leftTime then
		return
	end
	if GBaseInfo:GetEnergy() >= 100 then		
		self.idTimeText:setString("00:00")
		self.m_leftTime = 5*60
		return
	end
	self.m_leftTime = self.m_leftTime - dt
	if self.m_leftTime<0 then
		self.m_leftTime = 5*60
		GBaseInfo:AddEnergy(1,true)
	end
	self.idTimeText:setString(FormatTime(self.m_leftTime))
end
function FormatTime(time)
	local time = math.floor(time)
	local min = math.floor(time/60)
	local second = time - min*60
	return string.format("%02d:%02d",min,second)
end

function idAddRanLiao_OnTouch(self,eventType)
	if eventType == CCTOUCHENDED then				
		local ui = GPlay:AddUI("Active")
		if ui then
			ui:ShowActive("招财")
		end			
	end
end

function idAddZuanShi_OnTouch(self,eventType)
	Brocast:ShowMessage("封测阶段充值功能暂不开启","red")
	do return end
	if eventType == CCTOUCHENDED then				
		GPlay:AddUI("Pay")
	end
end

function idAddTiLi_OnTouch(self,eventType)
	if eventType == CCTOUCHENDED then
		local times = GBaseInfo:GetEnergyBuyTimes() + 1;
		local tab = Model.Config.Charges["BuyEnergy"..times]
		if tab == nil then
			Brocast:ShowMessage("亲,你的今日购买燃料次数已达上限！","red");
			return
		end

		local okfunc = 	function ()
							if GBaseInfo:GetEnergy() >= 255 then
								Brocast:ShowMessage("亲,你的燃料已达上限！","red");
							else
								GMaster:BuyEnergy();
							end
						end
		BigWinDlg:Show("#FFFFFF\n花费"..tab.price.."钻石,购买100点  燃料  吗？",okfunc,nil,2,"确 定",nil,"取 消",nil,"提    示")			
	end
end
