require "Model.Config.Levels"
module("Model.Play.PlayerInfo.UIPlayerInfo", MOInherit(Model.Base.UIBase))

function OnActivate(self)
	local scheduler = CCDirector:sharedDirector():getScheduler()
	self.m_timerEntry = scheduler:scheduleScriptFunc(function(dt) self:UpdateTimer(dt) end, 1, false)
	self.m_handlerEventBaseInfoChanged = GBaseInfo:AddListener("Event_BaseInfo_Changed",function(args) self.m_leftTime = nil Update(self,args) end)
 
	
	
	self.m_handlerEvent1 = GBaseInfo:AddListener("Event_BugEnergy_Changed",function () self.RefEnregyBuyTimes(self)	end)
	
	Update(self)
	
	self.idChangeCamp:setTouchEnabled(false)
	self.idChangeCamp:setEnabled(false)
end
function OnDeactivate(self)
	local scheduler = CCDirector:sharedDirector():getScheduler()
	scheduler:unscheduleScriptEntry(self.m_timerEntry)
	GBaseInfo:RemoveListener("Event_BaseInfo_Changed",self.m_handlerEventBaseInfoChanged)
	
	GBaseInfo:RemoveListener("Event_BugEnergy_Changed",self.m_handlerEvent1)

end

function UpdateTimer(self,dt)
	if not self.m_leftTime then
		return
	end

	self.idServerTime:setString(os.date("%Y/%m/%d      %H:%M:%S"))
	
	if GBaseInfo:GetEnergy() >= 100 then		
		self.idTimeText:setString("00:00:00")
		self.idAllResText:setString("00:00:00")
		self.m_leftTime = 6*60
		return
	end
	self.m_leftTime = self.m_leftTime - dt
	if self.m_leftTime<0 then
		self.m_leftTime = 6*60
		GBaseInfo:AddEnergy(1,true)
	end
	self.idTimeText:setString(FormatTime(self.m_leftTime))
	local currEnery = (100 - GBaseInfo:GetEnergy()-1)
	local lefttime = currEnery*360 + self.m_leftTime
	self.idAllResText:setString(FormatTime(lefttime))
	
end
function FormatTime(time)
	local time = math.floor(time)
	local hour = math.floor(time/60/60)
	local min = math.floor(time/60)
	local minite = min - hour * 60
	local second = time - min*60
	return string.format("%02d:%02d:%02d",hour,minite,second)
end
function Update(self)
	self.idName:setString(GBaseInfo:GetMasterName());
	local camp = GBaseInfo:GetCamp()
	if camp == 0 then
		self.idCamp:setString("商")
	else
		self.idCamp:setString("周")
	end
	self.idWei:setString(GBaseInfo:GetPrestige())	
	
	local curlevelexp = Model.Config.Levels.GetMasterLevelExp(GBaseInfo:GetLevel())
	local exp = GBaseInfo:GetExp()
	self.idExpText:setString(""..exp.."/"..curlevelexp.." ("..(math.floor(exp/curlevelexp*100)).."%)")
	
	local curlevelexp = Model.Config.Levels.GetMasterLevelExp(GBaseInfo:GetLevel())
	
	local percentage = self.idExpProgress:getPercentage()
	if exp*100/curlevelexp > percentage then
		self.idExpProgress:stopAllActions()
		local action = CCProgressFromTo:create(0.5,percentage,exp*100/curlevelexp)
		self.idExpProgress:runAction(action)
	else	
		self.idExpProgress:stopAllActions()
		local action = CCProgressFromTo:create(0.5,1,exp*100/curlevelexp)
		self.idExpProgress:runAction(action)
		self.idExpProgress:setPercentage(exp*100/curlevelexp);	
	end
	
	--self.idExpProgressText:setString("经验:");	
	
	
	self.idLv:SetType("lv")
	self.idExp:SetType("exp")
	self.idPriesthood:SetType("priesthood")	
	self.idExploit:SetType("exploit")
	self.idGold:SetType("gold")
	self.idMoney:SetType("money")
	self.idEnergy:SetType("ti")
	
	self.idLv:SetValue(GBaseInfo:GetLevel())
	self.idExp:SetValue(GBaseInfo:GetExp())
	self.idPriesthood:SetValue(GBaseInfo:GetPriesthood())	
	self.idExploit:SetValue(GBaseInfo:GetExploit())
	self.idGold:SetValue(GBaseInfo:GetGold())
	self.idMoney:SetValue(GBaseInfo:GetMoney())
	self.idEnergy:SetValue(GBaseInfo:GetEnergy())
	
	if not self.m_leftTime then
		local ui = CCModelManager:SharedManager():GetRootModel():FindModelComponent("/Play/HeadInfo","UI"):GetRootNode()
		self.m_leftTime = ui.m_leftTime
		if GBaseInfo:GetEnergy()>=100 then --当前燃料值
			self.idTimeText:setString("00:00:00")
			self.idAllResText:setString("00:00:00")
		else
			self.idTimeText:setString(FormatTime(self.m_leftTime))
			local currEnery = (100 - GBaseInfo:GetEnergy()-1)
			local lefttime = currEnery*360 + self.m_leftTime
			self.idAllResText:setString(FormatTime(lefttime))
		end
	end	
	
	self.idServerTime:setString(os.date("%Y/%m/%d      %H:%M:%S"))
	
	--全部恢复时间
	--self.idAllResText:setString("00:00:00")
	
	--已购买次数
	self.idBuyTimeText:setString(GBaseInfo:GetEnergyBuyTimes().."/"..GBaseInfo:GetEnergyBuyMaxTimes())
	
end

function RefEnregyBuyTimes(self)
	self.idBuyTimeText:setString(GBaseInfo:GetEnergyBuyTimes().."/"..GBaseInfo:GetEnergyBuyMaxTimes())
end
function idPay_OnTouch(self,eventType)
	Brocast:ShowMessage("封测阶段充值功能暂不开启","red")
	do return end
	if eventType == CCTOUCHENDED then
		local ui = GPlay:AddUI("Pay")
--		if ui then
--			ui:ShowDesc(2)
--		end
		self.m_script:RemoveSelf()
	end
end
function idBuy_OnTouch(self,eventType)
	if eventType == CCTOUCHENDED then
		
		if GBaseInfo:GetEnergy() >= 255 then
			Brocast:ShowMessage("燃料已达上限，无法购买","red")
			return 
		end
		
		if GBaseInfo:GetEnergyBuyTimes() >= GBaseInfo:GetEnergyBuyMaxTimes() then
			ShowGoldNotEnough("#FFFFFF今日已购买燃料次数"..GBaseInfo:GetEnergyBuyTimes().."次！         购买燃料次数不足，提高VIP等级可获得更多次数")
			return 
		end
		
		
		local n = GBaseInfo:GetEnergyBuyLeftTimes()
		local okfunc = function () GPlay:OpenItemShopList("energy") end
		OkCancelDlg:Show("#FFFFFF你可花费#00FF00"..GBaseInfo:GetBuyEnergyCost().."钻石#FFFFFF购买一管燃料。今天还可购买#00FF00"..n.."次。",okfunc,nil,0,"购买")
	end
end

function idChangeCamp_OnTouch(self,eventType)	
	if eventType == CCTOUCHENDED then
--[[		if GBaseInfo:GetGold()<500 then
			OkCancelDlg:Show("#FFFFFF变更阵营需要花费#00FF00500钻石#FFFFFF，你的钻石不足！",nil,nil,1)
			return
		end
		local okfunc = function () self.m_script:ChangeCamp() end
		local camp = GBaseInfo:GetCamp()
		if camp == 0 then
			OkCancelDlg:Show("#FFFFFF你当前是商阵营，确定要变更为#00FF00周#FFFFFF阵营吗？此操作需要花费#00FF00500钻石！",okfunc)
		else
			OkCancelDlg:Show("#FFFFFF你当前是周阵营，确定要变更为#00FF00商#FFFFFF阵营吗？此操作需要花费#00FF00500钻石！",okfunc)
		end--]]
	end
end