require "Model.Play.Pay.SCPayBase"

module("Model.Sdk.pp.SCPay",MOInherit(Model.Play.Pay.SCPayBase))


function OnActivate(self)
	base.OnActivate(self)
	init(self)
end

function OnDeactivate(self)
	base.OnDeactivate(self)
end
function init(self)		
	--订单状态，取值如下：无效订单='I'，新建='N'，支付中='P'，支付失败='F'，支付成功='S'，已兑换='E'，等待了结（即有另一个兑换还在进行中）='C'-->
  --有些平台支持支付中的状态而有些不支持，因此客户端应该在查询到新建的状态时延迟一会儿再次查询，直到次数达到后提示玩家再次查询或以后查询或放弃订单（放弃的时候需要提示用户确认未扣款）-->

	self.m_paylist = 
	{
	[1]={icon="",name="300元宝送月卡",desc="每日上线领取100元宝*30天",num=300,cost=30,type="monthcard",payinfo="10"},
	[2]={icon="",name="50元宝",desc="",num=50,cost=5,payinfo="1"},
	[3]={icon="",name="300元宝",desc="赠送30元宝",num=300,add=30,cost=30,payinfo="2"},
	[4]={icon="",name="1000元宝",desc="赠送100元宝",num=1000,add=100,cost=100,payinfo="3"},
	[5]={icon="",name="2000元宝",desc="赠送300元宝",num=2000,add=300,cost=200,payinfo="4"},
	[6]={icon="",name="5000元宝",desc="赠送1000元宝",num=5000,add=1000,cost=500,payinfo="5"}
	}		
	self.coinText = "元"	
	self.m_ui:UpdatePayUI(self)
	QueryOnLoad(self)
end
function OnPayResult(self,paramPPPayResultCode)
	SdkPlatform:sharedPlatform():SetCloseWebViewListener(nil)
	if paramPPPayResultCode == SdkStatusCode.PPPayResultCodeSucceed then
		self:Callbackfunc(GBaseInfo:GetOrderNum())
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeForbidden then--禁止访问
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeUserNotExist then--该用户不存在
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeParamLost then--必选参数丢失
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeNotSufficientFunds then--PP币余额不足
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeGameDataNotExist then--该游戏数据不存在
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeDeveloperNotExist then--开发者数据不存在
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeZoneNotExist then--该区数据不存在
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeSystemError then--系统错误
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeUserOffLine then--购买失败
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeCommunicationFail then--与开发商服务器通信失败
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeUntreatedBillNo then--开发商服务器未成功处理该订单
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeSystemError then--系统错误
		self:CancelOrder(GBaseInfo:GetOrderNum())
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeFail then--购买失败
		self:CancelOrder(GBaseInfo:GetOrderNum())
	elseif paramPPPayResultCode == SdkStatusCode.PPPayResultCodeCancel then--用户中途取消
		self:CancelOrder(GBaseInfo:GetOrderNum())
	else		
		self:CancelOrder(GBaseInfo:GetOrderNum())
	end
end

function OnCloseWebViewResult(self,paramPPWebViewCode)
	SdkPlatform:sharedPlatform():SetPayResultListener(nil)
	if paramPPWebViewCode == SdkStatusCode.PPWebViewCodeRecharge then
		self:CancelOrder(GBaseInfo:GetOrderNum())
	elseif paramPPWebViewCode == SdkStatusCode.PPWebViewCodeRechargeAndExchange then
		self:Callbackfunc(GBaseInfo:GetOrderNum())
	elseif paramPPWebViewCode == SdkStatusCode.PPWebViewCodeOther then
		self:CancelOrder(GBaseInfo:GetOrderNum())
	else
		self:CancelOrder(GBaseInfo:GetOrderNum())
	end
end

function OnCloseSdkViewResult(self,paramPPPageCode)
	if paramPPPageCode == SdkStatusCode.PPLoginViewPageCode then
	elseif paramPPPageCode == SdkStatusCode.PPRegisterViewPageCode then
	elseif paramPPPageCode == SdkStatusCode.PPOtherViewPageCode then
	else
	end
end

function CallPaySdk(self,ss)
	local data =  ss.m_packetSend.m_data
	--设置游戏客户端与游戏服务端链接方式【如果游戏服务端能主动与游戏客户端交互。例如发放道具则为长连接。此处设置影响充值并兑换的方式】
	SdkPlatform:sharedPlatform():EnableLongComet(false)
	
	local pPayListener = LuaSdkCodeListener:Create(function (paramPPPayResultCode) self:OnPayResult(paramPPPayResultCode) end)
	
	local cost =  data.cost
	if Model.Option.OptionManager.GetOption("VERSION_TEST") and _G["TEST_MODEL"] then
		cost = 1
	end
	SdkPlatform:sharedPlatform():SetPayResultListener(pPayListener)
	
	
	local closewebviewlistener = LuaSdkCodeListener:Create(function (paramPPWebViewCode) self:OnCloseWebViewResult(paramPPWebViewCode) end)
	SdkPlatform:sharedPlatform():SetCloseWebViewListener(closewebviewlistener)
	
	local closesdkviewlistener = LuaSdkCodeListener:Create(function (paramPPPageCode) self:OnCloseSdkViewResult(paramPPPageCode) end)
	SdkPlatform:sharedPlatform():SetCloseSdkViewListener(closesdkviewlistener)
	
	SdkPlatform:sharedPlatform():Pay(cost,ss.m_packetAskForOrderOk.m_order_num,data.name,data.payinfo,0)
end